Index: proiecte/Parallel-DT/R8/Src/getdata.c
===================================================================
--- proiecte/Parallel-DT/R8/Src/getdata.c	(revision 26)
+++ proiecte/Parallel-DT/R8/Src/getdata.c	(revision 32)
@@ -6,5 +6,4 @@
 /*************************************************************************/
 
-
 #include "defns.i"
 #include "types.i"
@@ -12,6 +11,4 @@
 
 #define Inc 2048
-
-
 
 /*************************************************************************/
@@ -25,49 +22,42 @@
 /*************************************************************************/
 
-    GetData(Extension)
-/*  --------  */
-    String Extension;
-{
-    FILE *Df, *fopen();
-    char Fn[100];
-    ItemNo i=0, j, ItemSpace=0;
-    Description GetDescription();
+GetData(Extension)
+	/*  --------  */
+	String Extension; {
+	FILE *Df, *fopen();
+	char Fn[100];
+	ItemNo i = 0, j, ItemSpace = 0;
+	Description GetDescription();
 
-    /*  Open data file  */
+	/*  Open data file  */
 
-    strcpy(Fn, FileName);
-    strcat(Fn, Extension);
-    if ( ! ( Df = fopen(Fn, "r") ) ) Error(0, Fn, "");
+	strcpy(Fn, FileName);
+	strcat(Fn, Extension);
+	if (!(Df = fopen(Fn, "r")))
+		Error(0, Fn, "");
 
-    do
-    {
-	MaxItem = i;
+	do {
+		MaxItem = i;
 
-	/*  Make sure there is room for another item  */
+		/*  Make sure there is room for another item  */
 
-	if ( i >= ItemSpace )
-	{
-	    if ( ItemSpace )
-	    {
-		ItemSpace += Inc;
-		Item = (Description *)
-			realloc(Item, ItemSpace*sizeof(Description));
-	    }
-	    else
-	    {
-		Item = (Description *)
-			malloc((ItemSpace=Inc)*sizeof(Description));
-	    }
-	}
+		if (i >= ItemSpace) {
+			if (ItemSpace) {
+				ItemSpace += Inc;
+				Item = (Description *) realloc(Item, ItemSpace
+						* sizeof(Description));
+			} else {
+				Item = (Description *) malloc((ItemSpace = Inc)
+						* sizeof(Description));
+			}
+		}
 
-	Item[i] = GetDescription(Df);
+		Item[i] = GetDescription(Df);
 
-    } while ( Item[i] != Nil && ++i );
+	} while (Item[i] != Nil && ++i);
 
-    fclose(Df);
-    MaxItem = i - 1;
+	fclose(Df);
+	MaxItem = i - 1;
 }
-
-
 
 /*************************************************************************/
@@ -84,97 +74,73 @@
 /*************************************************************************/
 
+Description GetDescription(Df)
+	/*          ---------------  */
+	FILE *Df; {
+	Attribute Att;
+	char name[500], *endname, *CopyString();
+	Boolean ReadName();
+	int Dv;
+	float Cv;
+	Description Dvec;
+	double strtod();
 
-Description GetDescription(Df)
-/*          ---------------  */
-    FILE *Df;
-{
-    Attribute Att;
-    char name[500], *endname, *CopyString();
-    Boolean ReadName();
-    int Dv;
-    float Cv;
-    Description Dvec;
-    double strtod();
+	if (ReadName(Df, name)) {
+		Dvec = (Description) calloc(MaxAtt + 2, sizeof(AttValue));
 
-    if ( ReadName(Df, name) )
-    {
-	Dvec = (Description) calloc(MaxAtt+2, sizeof(AttValue));
+		ForEach(Att, 0, MaxAtt) {
+			if (SpecialStatus[Att] == IGNORE) {
+				/*  Skip this value  */
 
-        ForEach(Att, 0, MaxAtt)
-        {
-	    if ( SpecialStatus[Att] == IGNORE )
-	    {
-		/*  Skip this value  */
+				DVal(Dvec, Att) = 0;
+			} else if (MaxAttVal[Att] || SpecialStatus[Att] == DISCRETE) {
+				/*  Discrete value  */
 
-		DVal(Dvec, Att) = 0;
-	    }
-	    else
-	    if ( MaxAttVal[Att] || SpecialStatus[Att] == DISCRETE )
-	    {
-		/*  Discrete value  */ 
+				if (!(strcmp(name, "?"))) {
+					Dv = 0;
+				} else {
+					Dv = Which(name, AttValName[Att], 1, MaxAttVal[Att]);
+					if (!Dv) {
+						if (SpecialStatus[Att] == DISCRETE) {
+							/*  Add value to list  */
 
-	        if ( ! ( strcmp(name, "?") ) )
-		{
-		    Dv = 0;
+							Dv = ++MaxAttVal[Att];
+							if (Dv > (int) AttValName[Att][0]) {
+								printf("\nToo many values for %s (max %d)\n",
+										AttName[Att], (int) AttValName[Att][0]);
+								exit(1);
+							}
+
+							AttValName[Att][Dv] = CopyString(name);
+						} else {
+							Error(4, AttName[Att], name);
+						}
+					}
+				}
+				DVal(Dvec, Att) = Dv;
+			} else {
+				/*  Continuous value  */
+
+				if (!(strcmp(name, "?"))) {
+					Cv = Unknown;
+				} else {
+					Cv = strtod(name, &endname);
+					if (endname == name || *endname != '\0')
+						Error(4, AttName[Att], name);
+				}
+				CVal(Dvec, Att) = Cv;
+			}
+
+			ReadName(Df, name);
 		}
-	        else
-	        {
-		    Dv = Which(name, AttValName[Att], 1, MaxAttVal[Att]);
-		    if ( ! Dv )
-		    {
-			if ( SpecialStatus[Att] == DISCRETE )
-			{
-			    /*  Add value to list  */
 
-			    Dv = ++MaxAttVal[Att];
-			    if ( Dv > (int) AttValName[Att][0] )
-			    {
-				printf("\nToo many values for %s (max %d)\n",
-					AttName[Att], (int) AttValName[Att][0]);
-				exit(1);
-			    }
+		if ((Dv = Which(name, ClassName, 0, MaxClass)) < 0) {
+			Error(5, "", name);
+			Dv = 0;
+		}
+		Class(Dvec) = Dv;
 
-			    AttValName[Att][Dv] = CopyString(name);
-			}
-			else
-			{
-			    Error(4, AttName[Att], name);
-			}
-		    }
-	        }
-	        DVal(Dvec, Att) = Dv;
-	    }
-	    else
-	    {
-		/*  Continuous value  */
-
-	        if ( ! ( strcmp(name, "?") ) )
-		{
-		    Cv = Unknown;
-		}
-	        else
-		{
-		    Cv = strtod(name, &endname);
-		    if ( endname == name || *endname != '\0' )
-			Error(4, AttName[Att], name);
-		}
-		CVal(Dvec, Att) = Cv;
-	    }
-
-	    ReadName(Df, name);
-        }
-
-        if ( (Dv = Which(name, ClassName, 0, MaxClass)) < 0 )
-        {
-	    Error(5, "", name);
-	    Dv = 0;
-        }
-	Class(Dvec) = Dv;
-
-	return Dvec;
-    }
-    else
-    {
-	return Nil;
-    }
+		return Dvec;
+	} else {
+		return Nil;
+	}
 }